{% extends 'proj/base.html' %}

{% comment %}Translation{% endcomment %}
{% load i18n %}

{% block scripts %}
{% load static %}

<script src="{% static 'dygraph.min.js' %}"></script>
<link rel="stylesheet" href="{% static 'dygraph.css' %}" type="text/css">
<link rel="stylesheet" href="{% static 'ol.css'%}" type="text/css">
<script src="{% static 'ol.js' %}"></script>

<!-- autocomplete stuff ; these are from histo app -->
<link rel="stylesheet" href="{% static 'autocomplete.css'%}" type="text/css">
<script src="{% static 'autocomplete.js' %}"></script>

<style>
/* Dygraphs */
.dygraph-legend > span { display: none; }
.dygraph-legend > span.highlight { display: inline; }
</style>

{% endblock %}
{% block links %}
<a class="clickable" style="color:red" onclick="document.getElementById('tuto').style.display='block'">{% trans 'help sheet' %}</a> &middot;
{% endblock %}

{% block tuto %}
<div id="tuto" onclick="this.style.display='none'">
    <div class="tutobox" style="position:absolute;bottom:15px;left:50%">
        {% trans '(click anywhere to close)' %}
    </div>
    <div style="position:absolute;top:20px;right:30px">
        {% trans 'read the manual for more' %}<img src="{% static 'img/corner-right-up.svg' %}">
    </div>
    <div class="tutobox" style="position:absolute;top:0;left:150px">
        <img src="{% static 'img/corner-left-down.svg' %}">{% trans 'top menu' %}
        <span style="font-size:medium">{% trans 'sets main parameter, models and scenario used, time variables' %}</span>
    </div>
    <div class="tutobox" style="position:absolute;top:65px;left:43%">
        <img src="{% static 'img/corner-left-down.svg' %}">{% trans 'place search'%}
    </div>
    <div class="tutobox" style="position:absolute;bottom:30%;left:10%">
        {% trans 'spatial variation map '%}<br>
        <span style="font-size:medium">{% trans 'upper menu sets spatial resolution<br>between large region and single-point station' %}</span>
    </div>
    <div class="tutobox" style="position:absolute;top:25%;right:20%">
        {% trans 'monthly (seasonal) graph' %}
        <br><span style="font-size:medium">{% trans 'displays averaged data for the selected time period'%}</span>
    </div>
    <div class="tutobox" style="position:absolute;bottom:30%;right:25%">
        {% trans 'yearly graph' %}
        <br><span style="font-size:medium">{% trans 'displays overall evolution on 150 years'%}</span>
        <br><span style="font-size:medium">{% trans 'click-and-drag horizontally to zoom'%}</span>
    </div>
    <div class="tutobox" style="position:absolute;top:15%;right:5px;text-align:right">
        {% trans 'graph legend' %}
<!--        <img src="{% static 'img/corner-right-up.svg' %}">-->
        <br><span style="font-size:medium">{% trans 'sets curve visibility<br>and model / scenario view'%}</span>
    </div>
</div>
{% endblock %}

{% block headinfo %}
{% get_current_language as LANGUAGE_CODE %}
<!-- Current language: {{ LANGUAGE_CODE }} -->

<form id="topForm">
    <div class="drop"><img style="height:1em" src="{% static 'img/cloud-rain.svg' %}">
        {% trans 'parameter' %} : <span id="paramName" class="dropSelected">{{ default_metric }}</span>
        <ul class="ul-large">
            {% for c in catmetric %}
            <li class="category">{{ c }}</li>
            {% for m in c.get_ordered_metrics %}
            <li class="hoverable"><input type="radio" name="metric" id="metric{{ m.id }}" value="{{ m.id }}"
                                         {% if m == default_metric %}checked{% endif %}
                                         onchange="updateMetricDrop({{ m.id }}, '{{ m }}')">
                <label for="metric{{ m.id }}">{{ m }}</label>
                {% if not m.monthly %}<span class="helptext" style="float:right;font-style:italic">{% trans 'per year only' %}</span>
                {% endif %}
            </li>
            {% endfor %}
            {% endfor %}
            <li class="category"><img src="{% static 'img/edit-3.svg' %}" style="height:1em"> {% trans 'custom formula' %}</li>
            <li class="hoverable">
                <input type="radio" name="metric" id="custommetric" value="-1"
                       onchange="updateCustom()">
            <label for="custommetric">
                <input style="width:50%" name="formulaText" type="text" onchange="updateCustom()"
                       placeholder="e.g. pr[pr>=3]">
                <select name="formulaAgg" onchange="updateCustom()">
                    <option value="count" selected>{% trans 'count' %}</option>
                    <option value="max">{% trans 'max' %}</option>
                    <option value="min">{% trans 'min' %}</option>
                    <option value="mean">{% trans 'average' %}</option>
                    <option value="sum">{% trans 'sum' %}</option>
                </select>
            </label></li>
            <li>{% trans 'map color' %} :
                <select name="formulaCmap" onchange="updateCustom()">
                {% for cmap in custom_cmap %}
                    <option value="{{ cmap.id }}">{{ cmap.locale_name }}</option>
                {% endfor %}
                </select>
            </li>
            <li class="helptext" style="float:right"> - <a
                    href="{% url 'proj:formula' %}">{% trans 'custom formula usage' %}</a></li>

            <li class="helptext" style="float:right"><a
                    href="{% url 'proj:about' %}#parameters">{% trans 'more about parameters' %}</a></li>
        </ul>

    </div>
    <div class="drop"><img style="height:1em" src="{% static 'img/list.svg' %}">
        {% trans 'models' %} : <span id="modelsNb" class="dropSelected">{{ models.count }}</span>
        <ul class="ul-large">
            <li>
                <input type="checkbox" id="modelall" onchange="allModels(this.checked);" checked><label
                    for="modelall"><i>{% trans 'all models' %}</i></label>
                <p class="helptext">{% trans 'If unsure, it is best to keep all models selected.' %}</p>

                <div style="column-count:2">
                    {% for m in models %}
                    <input type="checkbox" value="{{ m.id }}" name="models" class="modelCheck" id="model{{ m.id }}"
                           onchange="updateModelList()" checked><label for="model{{ m.id }}">{{ m.name }}</label><br>
                    {% endfor %}
                </div>
            </li>
            <li class="helptext" style="float:right"><a href="{% url 'proj:about' %}#models">
                {% trans 'more about models' %}</a></li>
        </ul>
    </div>
    <div class="drop"><img style="height:1em" src="{% static 'img/trending-up.svg' %}">
        scenario : <span id="scenName" class="dropSelected">{{ default_scenario }}</span>
        <ul class="ul-medium">
            {%for s in scenarii %}
            <li class="hoverable"><input value="{{ s.name }}" name="scenario" id="scen{{ s.id }}" type="radio"
                                         onchange="updateDrop('scen', '{{ s.name }}')"
                                         {% if s == default_scenario %}checked{% endif %}>
                <label for="scen{{ s.id }}">{{ s.name }} <span style="font-style:italic;color:gray">{{ s.locale_public_name }}</span></label></li>
            {% endfor %}
            <li class="helptext" style="float:right"><a
                    href="{% url 'proj:about' %}#scenarii">{% trans 'more about scenarii' %}</a></li>
        </ul>
    </div>
    <div class="drop"><img style="height:1em" src="{% static 'img/clock.svg' %}">
        {% trans 'period' %} : <span id="timeDisplay" class="dropSelected">{{ years }}</span>
        <ul class="ul-medium">
            <li>{% trans 'Month(s)' %} : <input class="small-input" name="months" type="text" value="1-12"
                                                onchange="updateTime(this.form);"></li>
            <li>{% trans 'Year(s)' %} : <input class="small-input" name='years' type="text" value={{ years }}
                                               onchange="updateTime(this.form);">
            </li>
            <li class="hoverable" id="data">{% trans 'Compare' %} <span class="dropSelected" id="dataName">{% trans 'no comparison' %}</span>
                <ul style="width:100%;left:50%">
                    <li class="hoverable"><input onchange="updateDrop('data', '{% trans 'raw data' %}');" value="data"
                                                 type="radio"
                                                 name="data"
                                                 id="data1" checked><label for="data1">{% trans 'no comparison' %}</label>
                    </li>
                    <li class="hoverable"><input onchange="updateDrop('data', '{% trans 'absolute difference' %}');"
                                                 value="absolute"
                                                 type="radio" name="data"
                                                 id="data2"><label for="data2">{% trans 'absolute difference' %} (delta)</label>
                    </li>
                    <li class="hoverable"><input onchange="updateDrop('data', '{% trans 'relative difference' %}');"
                                                 value="relative"
                                                 type="radio" name="data"
                                                 id="data3"><label for="data3">{% trans 'relative difference' %} (%)</label>
                    </li>
                </ul>
            <li id="refYrWidget">
                <img alt=">" height='12' src="{% static 'svg/corner-down-right.svg' %}">
                {% trans 'with reference to' %} <input class="small-input" name="refYrs" value="{{ default_refyrs }}"
                                                       type="text" onchange="updateAll()">
            </li>
            <li>{% trans 'Year rolling :' %} <input name="rolling" class="small-input" onchange="fetchData('y')" value="1"></li>
        </ul>
    </div>
    <div class="drop"><img style="height:1em" src="{% static 'img/download.svg' %}">
        {% trans 'export' %}
        <ul class="ul-small">
            <li class="category">{% trans 'as image' %}</li>
            <li class="hoverable clickable" onclick="exportAll('png')">{% trans 'png (image)' %}</li>
            <li class="hoverable clickable" onclick="exportAll('jpg')">{% trans 'jpg (image)' %}</li>
            <li class="hoverable clickable" onclick="exportAll('svg')">{% trans 'svg (scalable vector)' %}</li>
            <li class="hoverable clickable" onclick="exportAll('pdf')">{% trans 'pdf (document)'%}</li>
            <li class="category">{% trans 'data only' %}</li>
            <li id="month_export">{% trans 'monthly' %} <a id="month_csv">csv</a> &middot; <a id="month_xls">xls</a></li>
            <li >{% trans 'yearly' %} <a id="year_csv">csv</a> &middot; <a id="year_xls">xls</a></li>
            <li class="category">{% trans 'direct download' %}</li>
            <li><i>{% trans 'metrics'%} :</i></li>
            <li class="hoverable" style="padding-left:50px"><a href="{% url 'proj:download' %}#avgmetrics">{% trans 'averaged'%}</a></li>
            <li class="hoverable" style="padding-left:50px"><a href="{% url 'proj:download' %}#metrics">{% trans 'by model'%}</a></li>
<!--            <li class="hoverable" style="padding-left:50px"><a href="{% url 'proj:download' %}#netcdf">{% trans 'as grid'%}</a></li>-->
            <li class="hoverable"><a href="{% url 'proj:download' %}#params">{% trans 'raw parameters'%}</a></li>
        </ul>
    </div>
</form>

{% endblock %}
{% block content %}

<div id="mapContainer">
    <div>
    <h3 style="text-align:center" id="mapTitle"></h3>
        <div style="padding-left:50px">
        <div class="drop clickable" onclick="zoomOut();">
            <img style="height:1em" src="{% static 'img/zoom-out.svg' %}"> {% trans 'reset view' %}
        </div>
        <div class="drop">
            <img style="height:1em" src="{% static 'img/crosshair.svg' %}">
            {% trans 'selection' %} : <span id="selectionName" class="dropSelected">region</span>
            <ul class="ul-small">
                <li class="hoverable"><input {% if not station %}checked{% endif %} type="radio" name="selection" id="regionselection"
                                             onchange="updateSelect('region');updateMap()">
                    <label for="regionselection">region</label></li>
                <li class="hoverable"><input type="radio" name="selection" id="pixelselection"
                                             onchange="updateSelect('pixel');updateMap()">
                    <label for="pixelselection">pixel (0.5°x0.5°)</label></li>
                <li class="hoverable"><input {% if station %}checked{% endif %} type="radio" name="selection" id="stationselection"
                                             onchange="updateSelect('station')">
                    <label for="stationselection">{% trans 'weather station' %}</label></li>
            </ul>
        </div>
            <!--<div class="drop"><input id="showraster" name="showraster" type="checkbox" onchange="updateMap();">
                <label for="showraster">{% trans 'as grid' %}</label></div>-->
<!--            <div class="drop" id="stationLink"></div>-->

        <form autocomplete="off" style="height:1em;display:inline-block;float:right;">
        <div class="autocomplete">
            <img style="height:1em;display:inline-block;" src="{% static 'img/search.svg' %}">
            <input style="height:1em;display:inline-block" id="find_place" type="text" name="myCountry" placeholder="{% trans 'find place' %}">
            <input style="display:none;height:1em;" id="find_station" type="text" name="myCountry" placeholder="{% trans 'find station' %}">
        </div>
        </form>
        </div>
    </div>
    <div id="map" style="height:100%;"></div>
    <div id="newscale" style="display:block; position:absolute; top:50%; -ms-transform: translateY(-50%); transform: translateY(-50%); right:5px;">
        <table class="scaleTable">
            <tr>
                <td class="helptext" id="scale8">0</td>
                <td class="scaleO" id="scale8c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale7">0</td>
                <td class="scaleO" id="scale7c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale6">0</td>
                <td class="scaleO" id="scale6c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale5">0</td>
                <td class="scaleO" id="scale5c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale4">0</td>
                <td class="scaleO" id="scale4c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale3">0</td>
                <td class="scaleO" id="scale3c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale2">0</td>
                <td class="scaleO" id="scale2c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale1">0</td>
                <td class="scaleO" id="scale1c">&nbsp;</td>
            </tr>
            <tr>
                <td class="helptext" id="scale0">0</td>
                <td class="scaleO" id="scale0c">&nbsp;</td>
            </tr>
        </table>

    </div>
    <div id="error"></div>
    <p id="mapinfo" class="mapoverlay"></p>
</div>
<div id="rightPanel">
    <div id="rightTitle">{% trans 'Values for' %} <span id="rightTitleZone"></span></div>
    <form id="chartForm">
        <div class="legend">
            <div class="drop">
                {% trans 'compare' %} <span id="ZcompareName" class="dropSelected">{% trans compare %}</span>
                <ul style="min-width:150px;">
                    <li class="hoverable">
                        <input onchange="updateDropNoMap('Zcompare', '{% trans 'scenarii' %}')" type="radio"
                               name="compare"
                               id="Zcompare1"
                               value="scenarii"
                               {% if compare == 'scenarii' %}checked{% endif %}>
                        <label for="Zcompare1">{% trans 'scenarii' %}</label>
                    </li>
                    <li class="hoverable"><input onchange="updateDropNoMap('Zcompare', '{% trans 'models' %}')" type="radio"
                                                 name="compare"
                                                 id="Zcompare2"
                                                 value="models" {% if compare == 'models' %}checked{% endif %}>
                        <label for="Zcompare2">{% trans 'models' %}</label></li>
                </ul>
            </div>
            <div id="graphLegend" style="margin-top:20px"></div>
        </div>
    </form>
    <div class="chartContainer" id="monthChartContainer">
        <div id="monthUnit" style="position:absolute;top:30px;left:60px" class="helptext"></div>
        <div class="chart" id="monthChart"></div>
    </div>
    <div class="chartContainer" id="yearChartContainer">
        <div id="yearUnit" style="position:absolute;top:30px;left:60px" class="helptext"></div>
        <div class="chart" id="yearChart"></div>
    </div>
    <p class="helptext" style="text-align:center;">{% blocktrans trimmed %}The shaded zone in scenario view is the error bar
        (i.e. standard deviation of available models).<br>
        Drag-and-click to zoom on bottom chart. Double-click
        to reset. <a style="cursor:pointer" onclick="useRangeBounds()">Use these bounds</a>.{% endblocktrans %}</p>
</div>

<script src="{% static 'stations.js' %}"></script>
<script src="{% static 'proj.js' %}"></script>
{% get_current_language as LANGUAGE_CODE %}
{% if LANGUAGE_CODE == "fr" %}
<!-- overwrite some functions -->
<script src="{% static 'proj_fr.js' %}"></script>
{% endif %}

<script type="text/javascript">

var img_X = "{% static 'img/x-circle.svg' %}",
    img_eye = "{% static 'img/eye.svg' %}",
    img_eye_off = "{% static 'img/eye-off.svg' %}",
    img_toggle = "{% static 'img/refresh-cw.svg' %}",
    serverError = "{% trans 'Server error.' %}",
    lastObservationText = "{% trans 'observations' %}",
    main_zone = "{{ main_zone }}";

/* adjust map view : {{ view }} */
viewBounds = [{{ view }}]; fitView();

var values, scale,
    graph_color = {{ graph_color|safe }},
    metric = {{ default_metric.to_dict|safe }},
    thisUrl = "{% url 'proj:index' %}";

regions.setSource(new ol.source.Vector({
            features: (new ol.format.GeoJSON()).readFeatures({{ regions|safe }}),
            projection: 'EPSG:4326'
}));

/* places & autocomplete */


var stationFeatures = (new ol.format.GeoJSON()).readFeatures({{ stations|safe }}),
    station_list = {{ allstations|safe}};

stations.setSource(new ol.source.Vector({
            features: stationFeatures,
            projection: 'EPSG:4326'
}));

var allplaces = {{ allplaces|safe }},
    place_list = {{ allplaces_list|safe }},
    placeFinder = document.getElementById("find_place"),
    stationFinder = document.getElementById("find_station");
autocomplete(placeFinder, place_list);
autocomplete(stationFinder, station_list);

var places = new ol.layer.Vector({
	source: new ol.source.Vector({
            features: (new ol.format.GeoJSON()).readFeatures({{ places|safe }}),
            projection: 'EPSG:4326',
	}),
	zIndex: 100,
	style: textStyle,
	map: mymap /* only way to set z-index to +Infinity */
    });

mymap.addLayer(places);

{% if station %}
updateSelect('station');
stations.getSource().getFeatures().forEach(function(x){if (x.getProperties().pk=={{station}})
    {stationClick.getFeatures().push(x);goToStationPage(x);}});


{% endif %}


{% if args %}
var args = "{{ args|safe }}";
{% else %}
var args = getArgs();
{% endif %}

fetchData('mys');


var allMetrics = {{ allmetrics|safe}};

</script>

{% endblock %}
